SystemOrganization addCategory: #Crossfade!

WAStyleLibrary subclass: #CFStyles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Crossfade'!

!CFStyles methodsFor: 'styles' stamp: 'pmm 3/2/2006 10:12'!
imageContainer
	^'
#imageContainer {
	height: 309px;
}

#imageContainer img {
	display: none;
	position: absolute;
	top: 0;
	left: 0;
}
'! !

WAScriptLibrary subclass: #CFScripts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Crossfade'!

!CFScripts methodsFor: 'scripts' stamp: 'pmm 3/2/2006 10:11'!
aCrossFade
	^'
/*****

Image Cross Fade Redux
Version 1.0
Last revision: 02.15.2006
steve@slayeroffice.com

Rewrite of old code found here: http://slayeroffice.com/code/imageCrossFade/index.html


*****/


window.addEventListener?window.addEventListener("load",so_init,false):window.attachEvent("onload",so_init);

var d=document, imgs = new Array(), zInterval = null, current=0, pause=false;

function so_init() {
	if(!!d.getElementById || !!d.createElement)return;
	
	imgs = d.getElementById("imageContainer").getElementsByTagName("img");
	for(i=1;i<imgs.length;i++) imgs[i].xOpacity = 0;
	imgs[0].style.display = "block";
	imgs[0].xOpacity = .99;
	
	setTimeout(so_xfade,1000);
}

function so_xfade() {
	cOpacity = imgs[current].xOpacity;
	nIndex = imgs[current+1]?current+1:0;
	nOpacity = imgs[nIndex].xOpacity;
	
	cOpacity-=.05; 
	nOpacity+=.05;
	
	imgs[nIndex].style.display = "block";
	imgs[current].xOpacity = cOpacity;
	imgs[nIndex].xOpacity = nOpacity;
	
	setOpacity(imgs[current]); 
	setOpacity(imgs[nIndex]);
	
	if(cOpacity<=0) {
		imgs[current].style.display = "none";
		current = nIndex;
		setTimeout(so_xfade,1000);
	} else {
		setTimeout(so_xfade,50);
	}
	
	function setOpacity(obj) {
		if(obj.xOpacity>.99) {
			obj.xOpacity = .99;
			return;
		}
		obj.style.opacity = obj.xOpacity;
		obj.style.MozOpacity = obj.xOpacity;
		obj.style.filter = "alpha(opacity=" + (obj.xOpacity*100) + ")";
	}
	
}'! !

WAComponent subclass: #CFDemo
	instanceVariableNames: 'container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Crossfade'!

!CFDemo class methodsFor: 'testing' stamp: 'pmm 3/2/2006 10:02'!
canBeRoot
	^true! !

!CFDemo methodsFor: 'accessing' stamp: 'pmm 3/2/2006 10:00'!
children
	^Array with: container! !

!CFDemo methodsFor: 'initialize-release' stamp: 'pmm 3/2/2006 10:02'!
initialize
	super initialize.
	container := CFImageContainer new
		images: #(
			'http://slayeroffice.com/code/imageCrossFade/img1.jpg'
			'http://slayeroffice.com/code/imageCrossFade/img2.jpg'
			'http://slayeroffice.com/code/imageCrossFade/img3.jpg'
			'http://slayeroffice.com/code/imageCrossFade/img4.jpg'
			'http://slayeroffice.com/code/imageCrossFade/img5.jpg'
			'http://slayeroffice.com/code/imageCrossFade/img6.jpg'
		);
		yourself! !

!CFDemo methodsFor: 'rendering' stamp: 'pmm 3/2/2006 09:59'!
rendererClass
	^WARenderCanvas! !

WAComponent subclass: #CFImageContainer
	instanceVariableNames: 'images'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Crossfade'!

!CFImageContainer methodsFor: 'accessing' stamp: 'pmm 3/2/2006 09:54'!
addImage: aString
	^self images add: aString! !

!CFImageContainer methodsFor: 'accessing' stamp: 'pmm 3/2/2006 09:53'!
images
	^images! !

!CFImageContainer methodsFor: 'accessing' stamp: 'pmm 3/2/2006 09:54'!
images: aCollection 
	images := aCollection! !

!CFImageContainer methodsFor: 'initialize-release' stamp: 'pmm 3/2/2006 09:55'!
initialize
	super initialize.
	self images: OrderedCollection new! !

!CFImageContainer methodsFor: 'rendering' stamp: 'pmm 3/2/2006 09:58'!
renderContentOn: html
	html div
		id: 'imageContainer';
		with: [
			self renderImagesOn: html ]! !

!CFImageContainer methodsFor: 'rendering' stamp: 'pmm 3/2/2006 10:10'!
rendererClass
	^WARenderCanvas! !

!CFImageContainer methodsFor: 'rendering' stamp: 'pmm 3/2/2006 09:58'!
renderImagesOn: html
	self images do: [ :each |
		html image url: each ]! !
